<ToolboxBitmap(GetType(PromptingTextBox), "PromptingTextBoxTool.bmp")> _
Public Class PromptingTextBox
    Inherits TextBox

    ' Start displaying the prompt.
    Protected Overrides Sub OnCreateControl()
        MyBase.OnCreateControl()
        PromptingTextBox_LostFocus(Nothing, Nothing)
    End Sub

    Private m_Prompt As String = "(Prompt)"
    Public Property Prompt() As String
        Get
            Return m_Prompt
        End Get
        Set(ByVal Value As String)
            m_Prompt = Value
        End Set
    End Property

    Private Sub PromptingTextBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.GotFocus
        If Me.Text = m_Prompt Then Me.Text = ""
        Me.ForeColor = Color.Black
    End Sub

    Private Sub PromptingTextBox_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.LostFocus
        If Me.Text.Length = 0 Then Me.Text = m_Prompt
        If Me.Text = m_Prompt Then
            Me.ForeColor = Color.Gray
        Else
            Me.ForeColor = Color.Black
        End If
    End Sub

    Private Sub InitializeComponent()
        '
        'PromptingTextBox
        '

    End Sub
End Class